'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _immutable = require('immutable');

var _Coordinate = require('../../data/Coordinate');

var _Coordinate2 = _interopRequireDefault(_Coordinate);

var _CoordinateBuilder = require('../../data/builders/CoordinateBuilder');

var _CoordinateBuilder2 = _interopRequireDefault(_CoordinateBuilder);

var _TimeEstimatesSearch = require('../TimeEstimatesSearch');

var _TimeEstimatesSearch2 = _interopRequireDefault(_TimeEstimatesSearch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TimeEstimatesSearchBuilder = function () {
  function TimeEstimatesSearchBuilder() {
    _classCallCheck(this, TimeEstimatesSearchBuilder);
  }

  _createClass(TimeEstimatesSearchBuilder, null, [{
    key: 'build',
    value: function build(json) {
      if (!('start' in json)) {
        throw new TypeError('start is not in the search');
      }

      var args = (0, _immutable.Map)();
      if ('productId' in json) {
        if (typeof json['productId'] !== 'string') {
          throw new TypeError('product id is not a string');
        }
        args = args.set('productId', json['productId']);
      }

      args = args.set('start', _CoordinateBuilder2.default.build(json['start']));

      return new _TimeEstimatesSearch2.default(args);
    }
  }]);

  return TimeEstimatesSearchBuilder;
}();

exports.default = TimeEstimatesSearchBuilder;